unit os;

interface

{
  TaskRec.OS
  0 : No MultiTasking
  1 : Windows
  2 : OS/2
  3 : DESQview
  4 : TopView
}

type
  TaskRec = record
              OS      : Word;
              Version : Word;
              Delay   : Word;
            end;

const
  Task : TaskRec = (
       OS             : 0;
       Version        : 0;
       Delay          : 100
       );

procedure TimeSlice;
procedure InitMulti;

implementation

uses dos;

  procedure InitMulti; assembler;
  asm
    mov     Task.OS, 0
    mov     Task.Version, 0
    mov     ah, 30h
    mov     al, 01h
    int     21h
    cmp     al, 20
    je      @OS2
    mov     ax, 160Ah
    int     2Fh
    cmp     ax, 0
    je      @Windows
    mov     ax, 1022h
    mov     bx, 0000h
    int     15h
    cmp     bx, 0
    jne     @DESQview
    mov     ah, 2Bh
    mov     al, 01h
    mov     cx, 4445h
    mov     dx, 5351h
    int     21h
    cmp     al, $FF
   jne     @TopView
    jmp     @Fin
@Windows:
    mov     Task.OS, 1
    mov     Task.Version, bx
    jmp     @Fin
@OS2:
    mov     Task.OS, 2
    mov     bh, ah
    xor     ah, ah
    mov     cl, 10
    div     cl
    mov     ah, bh
    xchg    ah, al
    mov     Task.Version, ax
    jmp     @Fin
@DESQview:
    mov     Task.OS, 3
    jmp     @Fin
@TopView:
    mov     Task.OS, 4
@Fin:
  end;

  procedure TimeSlice; assembler;
  asm
    cmp     Task.OS, 0
    je      @Fin
    cmp     Task.OS, 1
    je      @Win_OS2
    cmp     Task.OS, 2
    je      @Win_OS2
@DV_TV:
    mov     ax, 1000h
    int     15h
    jmp     @Fin
@Win_OS2:
    mov      ax, 1680h
    int     2Fh
@Fin:
  end;

end.

